
/*
 * Copyright (c) 2001-2003 Shiman Associates Inc. All Rights Reserved.
 * 
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

/* $Id: masdbscale.h,v 1.2 2004/03/01 23:32:42 silvio Exp $ */

#ifndef __MASDBSCALE_H__
#define __MASDBSCALE_H__

    
#include <gtk/gtk.h>

#ifdef __cplusplus
extern "C" {
#endif

#define MDS_LEAVE_COLORS 1
#define MDS_BLACK_COLORS 0

/* empirically determined; for all themes I've seen, the sliders are
   18+19 pixels high. Hope that it's always true. */    
#define MDS_GTKSLIDERAD 18

struct mds_options
{
    gboolean ismono;
    gboolean leave_colors;
    gboolean isflush; /* is the scale flush at top & bottom or MDS_GTKSLIDERAD inset? */
    int db_cutoff;
    int (*incr_func)( int i );
    int (*val_func)( int i );
};
    
    
extern guint gtk_masdbscale_get_type();
    
#define GTK_TYPE_MASDBSCALE		(gtk_masdbscale_get_type ())
#define GTK_MASDBSCALE(obj)		(GTK_CHECK_CAST ((obj), GTK_TYPE_MASDBSCALE, GtkMasdbscale))
#define GTK_MASDBSCALE_CLASS(klass)	(GTK_CHECK_CLASS_CAST ((klass), GTK_TYPE_MASDBSCALE, GtkMasdbscaleClass))
#define GTK_IS_MASDBSCALE(obj)		(GTK_CHECK_TYPE ((obj), GTK_TYPE_MASDBSCALE))
#define GTK_IS_MASDBSCALE_CLASS(klass)	(GTK_CHECK_CLASS_TYPE ((klass), GTK_TYPE_MASDBSCALE))


typedef struct _GtkMasdbscale       GtkMasdbscale;
typedef struct _GtkMasdbscaleClass  GtkMasdbscaleClass;

struct _GtkMasdbscale
{
    GtkDrawingArea darea;
    gboolean ismono;
    gboolean leave_colors;
    gboolean isflush;
    int db_cutoff;
    int (*incr_func)( int i );
    int (*val_func)( int i );
    PangoLayout *layout;
    int oldmaxw;
};
    
enum gtk_masdbscale_options
{
  MDS_MONO   = 1,
  MDS_STEREO = 2
};


struct _GtkMasdbscaleClass
{
    GtkDrawingAreaClass parent_class;
};

GtkWidget* gtk_masdbscale_new( struct mds_options *opts );
void gtk_masdbscale_set_db_cutoff(GtkWidget* w, int new_cutoff);

#ifdef __cplusplus
}
#endif
/* __MASDBSCALE_H__ */
#endif
