/*
 * Copyright (c) 2001-2003 Shiman Associates Inc. All Rights Reserved.
 * 
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

#ifndef _RTP_TRANSPORT_H
#define _RTP_TRANSPORT_H

/* RTP session type bitfield */
#define RTP_SESSTYPE_NONE             0
#define RTP_SESSTYPE_UNIX             1<<0
#define RTP_SESSTYPE_TCP              1<<1
#define RTP_SESSTYPE_UDP              1<<2
#define RTP_SESSTYPE_FIFO             1<<3
#define RTP_SESSTYPE_XCLIENTMSG       1<<4

/* yaargh! /usr/include/sys/un.h hard-codes this to 104 on my aix
 * box. Hope it'll work everywhere else. */
#ifdef aix
# define RTP_UNIX_PATH_MAX             104
#else
# define RTP_UNIX_PATH_MAX             108
#endif

#define RTP_LISTEN_BACKLOG            5

#define RTP_PT_MAS                    42

#endif /* _RTP_TRANSPORT_H */


